﻿namespace XamDataGridDynamicColumns
{
    using System;
    using System.Linq;
    using System.Windows;
    using System.Windows.Data;
    using Infragistics.Windows.DataPresenter;
    using Infragistics.Windows.DataPresenter.Events;
    using System.Collections.Generic;
   
    /// <summary>
    ///     Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            
        }

        public StaffMemberViewModel ViewModel
        {
            get { return this.DataContext as StaffMemberViewModel; }
        }

        private void xamDataGrid_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            //a cheat to get the number of columns to create.
            var staffMember = this.ViewModel.StaffMembers.First();

            for (Int32 i = 0; i < staffMember.Periods.Count; i++)
            {
                var field = new Field
                {
                    Name = staffMember.Periods[i].Title,
                };

                field.AllowEdit = false;

                field.Settings.EditAsType = typeof(Int32);

                e.FieldLayout.Fields.Add(field);
            }
        }
    }


    public class Myconverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null)
            {
                return (value as StaffMember).Periods;
            }
          return   Binding.DoNothing;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return Binding.DoNothing;
           
        }
    }

    public class MultiConverter : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (values != null)
            {
                int index = ((values[1] as CellValuePresenter).Record.Index);
                var list = values[0] as IList<Period>;
                if (index != null && list != null)
                {
                      return list[index];
                }
            }
            return Binding.DoNothing;
          
            
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {

            throw new NotImplementedException();
        }
    }


}